#include <c4d.h>
#include <c4d_quaternion.h>
#include "skeleton.h"
#include "ExportParameters.h"

// The exporter class
class Ogre3D_Exporter : public CommandData
{
public:
    ExportParameters parameters;    // Export parameters
    Vector* normals_array;    // Array containing normals

    Bool Execute(BaseDocument* doc);    // Main exporter function
    LONG GetState(BaseDocument* doc);
    Bool TriangulateObject(BaseDocument* doc,BaseObject* object);    // A call to the tringulate modeling command
    void CalculateNormals(PolygonObject* object);    // Calculates the normal for each vertex
    void PrepareObjectForUVExport(PolygonObject* object);    //Creates new points so a point isn't owned by multiple polygons (needed for correct UV export, am I wrong ? )
    Vector* GetUVData(PolygonObject* object);    // Retrieves UV data from a UV tag
    String* GetVertexMaps(SkeletonElement* skeleton_element);    // Retrieves a list of all the vertexmaps associated with a bone
    String GetMaterialName(BaseObject* object);    // Retrieves a material name from a material tag
    Filename* SelectFilename();    // Opens a file selection dialog
    Filename* SelectPath();    // Opens a path selection dialog
    void WriteString(String string,BaseFile* file);    // Writes a string in an opened file
    void WriteMeshXMLFile(BaseObject* object,BaseDocument* doc,Filename* fname);    // Writes mesh data
    void WriteSkeletonXMLFile(BaseObject* object,BaseDocument* doc,Filename* fname);    // Writes skeleton data
};
